<?php
/*
Plugin Name: BGColor Setter
Description: Lets any visitor dynamically set background color of WordPress blog within widget.
Version: 1.0
Author: Grigori
License: GPL2
*/

class Bgcolor_Setter extends WP_Widget {
    function Bgcolor_Setter() {
        $widget_ops = array('classname' => 'Bgcolor_Setter', 'description' => 'Widget for setting background color of WordPress blog');
        $this->WP_Widget('Bgcolor_Setter', 'BGColor Setter', $widget_ops);
        }
    
    function widget($args, $instance) {
        extract($args);
        $title = apply_filters('widget_title', $instance['title']);
        if(isset($_COOKIE['bgcolor']))
		echo '<style type="text/css">body{ background-color:#' . $_COOKIE['bgcolor'] . ';}</style>';
        echo $before_widget;
        if($title)
            echo $before_title . $title . $after_title;
        // If want to add custom colors to existing ones, add it's hex numbers to $options.
        // Then see 'functions.js' file
        $options = array('Default', '00FF00', '00FFFF', '9933FF', 'FF0033');?>
	<script type="text/javascript" src="functions.js">
	</script>
	<form onsubmit="createCookie()">
        <select id="sel" onchange="dc()">
            <?php foreach($options as $option)
                echo '<option>' . $option . '</option>';?>
        </select><br />
        <span id="ctext"></span><br />
        <input type="submit" value="Save" />
        </form><?php
        echo $after_widget; 
	}
    
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        return $instance;
        }
        
    function form($instance) {
        $title = esc_attr($instance['title']);
        ?>
        <label for="<?php echo $this->get_field_id('title'); ?>">Enter widget title:</label><br />
        <input type="text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title');?>" value="<?php echo $title;?>" />
        <br /><br />
        <?php if(isset($_COOKIE['bgcolor']))
            echo 'Current background color is: <span style="color:#' . $_COOKIE['bgcolor'] . '">' . $_COOKIE['bgcolor'] . '</span>';
        else
            echo 'Default background color.';
        }
    }
    add_action('widgets_init', create_function('', 'return register_widget("Bgcolor_Setter");'));
?>